program ColorMeter;

uses Windows, messages, graphics, sysutils, mmsystem;

{$R resur.RES}

const
      // Stop    // DEC     // HEX     // R       // G        // B        // RES     // X        // Y
      b1x=8;     l1x=41;    l2x=84;    l3x=17;    l4x=17;     l5x=18;     l6x=4;     l7x=134;    l8x=134;
      b1y=112;   l1y=1;     l2y=1;     l3y=18;    l4y=41;     l5y=63;     l6y=90;    l7y=20;     l8y=40;
      b1w=196;   l1w=25;    l2w=25;    l3w=14;    l4w=14;     l5w=14;     l6w=26;    l7w=9;      l8w=9;
      b1h=21;    l1h=13;    l2h=13;    l3h=13;    l4h=13;     l5h=13;     l6h=13;    l7h=13;     l8h=13;
      // Rd      // Bd
      e1x=35;    e5x=35;
      e1y=14;    e5y=62;
      e1w=39;    e5w=39;
      e1h=21;    e5h=21;
      // Rh      // Bh
      e2x=78;    e6x=78;
      e2y=14;    e6y=62;
      e2w=39;    e6w=39;
      e2h=21;    e6h=21;
      // Gd      // RES
      e3x=35;    e7x=35;
      e3y=38;    e7y=86;
      e3w=39;    e7w=82;
      e3h=21;    e7h=21;
      // Gh      // X       // Y
      e4x=78;    e8x=150;   e9x=150;
      e4y=38;    e8y=14;    e9y=38;
      e4w=39;    e8w=53;    e9w=53;
      e4h=21;    e8h=21;    e9h=21;
type
 trgb = record  //     ,     
  b,g,r: byte;
 end;
 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

var
  MainWND: thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg: TMsg;
  but1,ed1,ed2,ed3,ed4,ed5,ed6,ed7,ed8,ed9,l1,l2,l3,l4,l5,l6,l7,l8: THandle;
  Desktop:TBitmap;
  ps: array of PARGB;
  timer,event1:thandle;
  grt: trect; 
  Thr: longword;
  trig: boolean = true;

procedure CallBackTime(TimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD) stdcall;
begin
 SetEvent(event1);
end;

procedure Wait(duration:integer);
begin
 Timer:=timeSetEvent(duration,4,@CallBackTime,0,TIME_ONESHOT);
 WaitForSingleObject(event1, infinite);
 timeKillEvent(Timer);
end;

function Doedin(x:extended):integer; //,  
begin
 if trunc(frac(x)*10)>4 then result:=trunc(x)+1 else result:=trunc(x);
end;

function GetCaption(wnd:Thandle):string;
begin
 setlength(result,255);
 setlength(result,getwindowtext(wnd,pchar(result),255));
end;

procedure CalcProc;
 var p:tpoint;
 R,G,B:byte;
 dc:hdc;
begin
  R:=0;
  G:=0;
  B:=0;
 repeat
  GetCursorPos(p);
  dc:=getdc(0);
  bitblt(Desktop.Canvas.handle,0,0,1,1,dc,p.X,p.Y,srccopy);
  releasedc(0,dc);
  if GetCaption(but1)='Stop' then begin
   R:=PS[0,0].R;
   G:=PS[0,0].G;
   B:=PS[0,0].B;
   SetWindowText(ed1,pchar(inttostr(R)));
   SetWindowText(ed2,pchar(format('%x',[R])));
   SetWindowText(ed3,pchar(inttostr(G)));
   SetWindowText(ed4,pchar(format('%x',[G])));
   SetWindowText(ed5,pchar(inttostr(B)));
   SetWindowText(ed6,pchar(format('%x',[B])));
   SetWindowText(ed7,pchar(inttostr(R+G*256+B*65536)));
  end else begin
   SetWindowText(mainwnd,pchar(inttostr(doedin(sqrt((PS[0,0].R-R)*(PS[0,0].R-R)+
                                                    (PS[0,0].G-G)*(PS[0,0].G-G)+
                                                    (PS[0,0].B-B)*(PS[0,0].B-B))))));
  end;
  SetWindowText(ed8,pchar(inttostr(p.X)));
  SetWindowText(ed9,pchar(inttostr(p.Y)));
  wait(5);
 until trig;
 Desktop.Free;
end;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
begin
  Result:=0;
  case Msg of
   WM_COMMAND:if (HIWORD(wParam)=BN_CLICKED)and(trig=false) then begin
     if cardinal(lparam)=but1 then begin
      if GetCaption(but1)='Stop' then begin
       SetWindowText(but1,'Start');
      end else begin
       SetWindowText(but1,'Stop');
       SetWindowText(mainwnd,' Color meter');
      end;                                    
     end;
   end else Result:=DefWindowProc(Wnd, Msg, wParam, lParam);

   WM_CREATE: begin
    But1:=CreateWindow('BUTTON', 'Stop', WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE or DS_3DLOOK	,b1x,b1y,b1w,b1h,Wnd,0,hInstance,nil);
    SendMessage(But1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed1:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e1x,e1y,e1w,e1h,Wnd,0,hInstance,nil);
    SendMessage(ed1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed2:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e2x,e2y,e2w,e2h,Wnd,0,hInstance,nil);
    SendMessage(ed2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed3:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e3x,e3y,e3w,e3h,Wnd,0,hInstance,nil);
    SendMessage(ed3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed4:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e4x,e4y,e4w,e4h,Wnd,0,hInstance,nil);
    SendMessage(ed4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed5:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e5x,e5y,e5w,e5h,Wnd,0,hInstance,nil);
    SendMessage(ed5,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed6:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e6x,e6y,e6w,e6h,Wnd,0,hInstance,nil);
    SendMessage(ed6,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed7:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e7x,e7y,e7w,e7h,Wnd,0,hInstance,nil);
    SendMessage(ed7,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed8:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e8x,e8y,e8w,e8h,Wnd,0,hInstance,nil);
    SendMessage(ed8,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ed9:=CreateWindow('EDIT','',WS_CHILD or ES_NUMBER
     or WS_VISIBLE,e9x,e9y,e9w,e9h,Wnd,0,hInstance,nil);
    SendMessage(ed9,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l1:=CreateWindow('STATIC','DEC',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l1x,l1y,l1w,l1h,Wnd,0,hInstance,nil);
    SendMessage(l1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l2:=CreateWindow('STATIC','HEX',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l2x,l2y,l2w,l2h,Wnd,0,hInstance,nil);
    SendMessage(l2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l3:=CreateWindow('STATIC','R',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l3x,l3y,l3w,l3h,Wnd,0,hInstance,nil);
    SendMessage(l3,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l4:=CreateWindow('STATIC','G',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l4x,l4y,l4w,l4h,Wnd,0,hInstance,nil);
    SendMessage(l4,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l5:=CreateWindow('STATIC','B',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l5x,l5y,l5w,l5h,Wnd,0,hInstance,nil);
    SendMessage(l5,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l6:=CreateWindow('STATIC','RES',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l6x,l6y,l6w,l6h,Wnd,0,hInstance,nil);
    SendMessage(l6,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l7:=CreateWindow('STATIC','X',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l7x,l7y,l7w,l7h,Wnd,0,hInstance,nil);
    SendMessage(l7,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    l8:=CreateWindow('STATIC','Y',WS_CHILD or SS_LEFT
     or WS_VISIBLE,l8x,l8y,l8w,l8h,Wnd,0,hInstance,nil);
    SendMessage(l8,WM_SETFONT,hFontbold,MAKELPARAM(0,0));    

    SetFocus(But1);
    result:=0;
   end;

   WM_DESTROY:begin
    trig:=true;
    DeleteObject(hFontBold);
    unregisterclass('ColorMeter',hinstance);
    postquitmessage(0);
   end;

  else
   Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
  end;
end;

BEGIN
 hFontBold:=CreateFont(8,0,0,0,FW_BOLD,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');
 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=5;
 WC.lpszClassName:='ColorMeter';
 RegisterClass(WC);
 systemparametersinfo(spi_getworkarea, 0, @grt, 0);
 MainWND:=CreateWindow('ColorMeter',' Color meter',WS_SYSMENU or WS_MINIMIZEBOX,0,0,0,0,0,0,hInstance,nil);
 SetWindowPos(MainWnd,HWND_TOPMOST,(grt.Right-220) div 2,(grt.Bottom-165) div 2,220,165,SWP_SHOWWINDOW);

 Desktop:=tbitmap.Create;
 Desktop.PixelFormat:=pf24bit;
 Desktop.Width:=1;
 Desktop.Height:=1;
 PS:=nil;
 setlength(PS,Desktop.Height);
 PS[0]:=Desktop.scanline[0];
 event1:=CreateEvent(nil, false, false, nil);
 trig:=false;
 CreateThread(nil,0,@CalcProc,nil,0,Thr);

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
